﻿Imports System.Data
Imports System.Data.SqlClient

Public Class Form1

    Private Const ConnectionString As String = "Data Source=.\SQL2017;Initial Catalog=AjaxSamples;Integrated Security = true"
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.BindGrid()
    End Sub
    Private Sub BindGrid()
        Using con As New SqlConnection(ConnectionString)
            Using cmd As New SqlCommand("SELECT CustomerId, Name, Country FROM Customers", con)
                cmd.CommandType = CommandType.Text
                Using sda As New SqlDataAdapter(cmd)
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        dataGridView1.DataSource = dt
                    End Using
                End Using
            End Using
        End Using

        'Add a CheckBox Column to the DataGridView at the first position.
        Dim checkBoxColumn As New DataGridViewCheckBoxColumn()
        checkBoxColumn.HeaderText = ""
        checkBoxColumn.Width = 30
        checkBoxColumn.Name = "checkBoxColumn"
        dataGridView1.Columns.Insert(0, checkBoxColumn)

        'Assign Click event to the DataGridView Cell.
        AddHandler dataGridView1.CellContentClick, AddressOf DataGridView_CellClick
    End Sub
    Private Sub DataGridView_CellClick(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs)
        'Check to ensure that the row CheckBox is clicked.
        If e.RowIndex >= 0 AndAlso e.ColumnIndex = 0 Then
            'Loop and uncheck all other CheckBoxes.
            For Each row As DataGridViewRow In dataGridView1.Rows
                If row.Index = e.RowIndex Then
                    row.Cells("checkBoxColumn").Value = Not Convert.ToBoolean(row.Cells("checkBoxColumn").EditedFormattedValue)
                Else
                    row.Cells("checkBoxColumn").Value = False
                End If
            Next
        End If
    End Sub
End Class
